/*
*********************************************************************************************************
*
*	ģ : BSPģ(For STM32F429)
*	ļ : bsp.c
*	     : V1.0
*	˵     : Ӳײļÿcļ #include "bsp.h" еģ顣
*			   bsp = Borad surport packet 弶ְ֧
*	޸ļ¼ :
*		汾                  ˵
*		V1.0    2018-07-29  Eric2013   ʽ
*
*	Copyright (C), 2018-2030,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"
#include "modbus_host.h"



/*
*********************************************************************************************************
*	                                   
*********************************************************************************************************
*/
static void SystemClock_Config(void);


/*
*********************************************************************************************************
*	  : bsp_Init
*	˵: ʼеӲ豸úCPUĴļĴʼһЩȫֱֻҪһ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_Init(void)
{
	/* 
       STM32H429 HAL ʼʱϵͳõĻF429Դ16MHzHSIʱ:
	   - úHAL_InitTickʼδʱж1ms
	   - NVIVȼΪ4
	 */
	HAL_Init();

	/* 
       ϵͳʱӵ168MHz
       - лʹHSE
       - ˺ȫֱSystemCoreClockHAL_InitTick
    */
	SystemClock_Config();

	/* 
	   Event Recorder
	   - ڴִʱMDK5.25ϰ汾֧֣IAR֧֡
	   - ĬϲҪʹܴѡؿV5ûֲ8
	*/	
#if Enable_EventRecorder == 1  
	/* ʼEventRecorder */
	EventRecorderInitialize(EventRecordAll, 1U);
	EventRecorderStart();
#endif
	
	bsp_InitKey();    	/* ʼҪڵδʱ֮ǰΪťͨδʱɨ */
	bsp_InitTimer();  	/* ʼδʱ */
	bsp_InitUart();		/* ʼ */
	bsp_InitExtIO();    /* ʼչIO */
	bsp_InitLed();    	/* ʼLED */	
	BEEP_InitHard();    /* ʼ */
}

/*
*********************************************************************************************************
*	  : SystemClock_Config
*	˵: ʼϵͳʱ
*            	System Clock source            = PLL (HSE)
*            	SYSCLK(Hz)                     = 168000000 (CPU Clock)
*            	HCLK = SYSCLK / 1              = 168000000 (AHB1Periph)
*            	PCLK2 = HCLK / 2               = 84000000  (APB2Periph)
*            	PCLK1 = HCLK / 4               = 42000000  (APB1Periph)
*            	HSE Frequency(Hz)              = 25000000
*           	PLL_M                          = 25
*            	PLL_N                          = 336
*            	PLL_P                          = 2
*            	PLL_Q                          = 4
*            	VDD(V)                         = 3.3
*            	Flash Latency(WS)              = 5
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void SystemClock_Config(void)
{
	RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
	RCC_OscInitTypeDef RCC_OscInitStruct = {0};

	
	/* оƬڲLDOѹĵѹΧѡõPWR_REGULATOR_VOLTAGE_SCALE1 */
	__HAL_RCC_PWR_CLK_ENABLE();
	__HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

	/* ʹHSEѡHSEΪPLLʱԴ */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
	RCC_OscInitStruct.HSEState = RCC_HSE_ON;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
	RCC_OscInitStruct.PLL.PLLM = 8;
	RCC_OscInitStruct.PLL.PLLN = 336;
	RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
	RCC_OscInitStruct.PLL.PLLQ = 4;
	if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{
        Error_Handler(__FILE__, __LINE__);
	}

	/* 
       ѡPLLΪϵͳʱ
		HCLK = SYSCLK / 1  (AHB1Periph)
		PCLK2 = HCLK / 2   (APB2Periph)
		PCLK1 = HCLK / 4   (APB1Periph)
    */
	RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
								  |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
	RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

	/* ˺SystemCoreClockHAL_InitTick */
	if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
	{
        Error_Handler(__FILE__, __LINE__);
	}

    /* ʹSYSʱӺIO */
	__HAL_RCC_SYSCFG_CLK_ENABLE() ;

	HAL_EnableCompensationCell();
}

/*
*********************************************************************************************************
*	  : Error_Handler
*	    : file : Դļơؼ __FILE__ ʾԴļ
*			  line кšؼ __LINE__ ʾԴк
*	  ֵ: 
*		Error_Handler(__FILE__, __LINE__);
*********************************************************************************************************
*/
void Error_Handler(char *file, uint32_t line)
{
	/* 
		ûԼĴ뱨Դļʹкţ罫ļкŴӡ
		printf("Wrong parameters value: file %s on line %d\r\n", file, line) 
	*/
	
	/* һѭʧʱڴ˴Աû */
	if (line == 0)
	{
		return;
	}
	
	while(1)
	{
	}
}

/*
*********************************************************************************************************
*	  : bsp_RunPer10ms
*	˵: úÿ10msSystickжϵ1Ρ bsp_timer.cĶʱжϷһЩʱҪϸ
*			Էڴ˺磺ɨ衢пƵȡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_RunPer10ms(void)
{
	bsp_KeyScan10ms();
	BEEP_Pro();
}

/*
*********************************************************************************************************
*	  : bsp_RunPer1ms
*	˵: úÿ1msSystickжϵ1Ρ bsp_timer.cĶʱжϷһЩҪԴ
*			 Էڴ˺磺ɨ衣
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_RunPer1ms(void)
{
	
}

/*
*********************************************************************************************************
*	  : bsp_Idle
*	˵: ʱִеĺһforwhileѭҪ CPU_IDLE() ñ
*			 ȱʡΪղûιCPUģʽĹܡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_Idle(void)
{
	/* --- ι */

	/* --- CPUߣSystickʱжϻѻжϻ */

	/*  emWin ͼο⣬ԲͼοҪѯ */
	//GUI_Exec();

	/*  uIP Э飬Բuipѯ */
	//TOUCH_CapScan();
	
	MODH_Poll();
}

/*
*********************************************************************************************************
*	  : HAL_Delay
*	˵: ضӳٺ滻HALеĺΪHALеȱʡSystickжϣUSBSD
*             жӳٺҲͨHAL_NVIC_SetPrioritySystickж
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
/* ǰʹstm32f4xx_hal.cĬϷʽʵ֣δʹضĺ */
#if 0
void HAL_Delay(uint32_t Delay)
{
	bsp_DelayUS(Delay * 1000);
}
#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
