/*
*********************************************************************************************************
*
*	ģ : cpuڲfalshģ(for F4)
*	ļ : bsp_cpu_flash.c
*	     : V1.0
*	˵     : ṩдCPUڲFlashĺ
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"


/*
*********************************************************************************************************
*	  : bsp_GetSector
*	˵: ݵַ׵ַ
*	    :  
*	  ֵ: ׵ַ
*********************************************************************************************************
*/
uint32_t bsp_GetSector(uint32_t Address)
{
	uint32_t sector = 0;

	if((Address < ADDR_FLASH_SECTOR_1) && (Address >= ADDR_FLASH_SECTOR_0))
	{
		sector = FLASH_SECTOR_0;
	}
	else if((Address < ADDR_FLASH_SECTOR_2) && (Address >= ADDR_FLASH_SECTOR_1))
	{
		sector = FLASH_SECTOR_1;
	}
	else if((Address < ADDR_FLASH_SECTOR_3) && (Address >= ADDR_FLASH_SECTOR_2))
	{
		sector = FLASH_SECTOR_2;
	}
	else if((Address < ADDR_FLASH_SECTOR_4) && (Address >= ADDR_FLASH_SECTOR_3))
	{
		sector = FLASH_SECTOR_3;
	}
	else if((Address < ADDR_FLASH_SECTOR_5) && (Address >= ADDR_FLASH_SECTOR_4))
	{
		sector = FLASH_SECTOR_4;
	}
	else if((Address < ADDR_FLASH_SECTOR_6) && (Address >= ADDR_FLASH_SECTOR_5))
	{
		sector = FLASH_SECTOR_5;
	}
	else if((Address < ADDR_FLASH_SECTOR_7) && (Address >= ADDR_FLASH_SECTOR_6))
	{
		sector = FLASH_SECTOR_6;
	}
	else if((Address < ADDR_FLASH_SECTOR_8) && (Address >= ADDR_FLASH_SECTOR_7))
	{
		sector = FLASH_SECTOR_7;
	}
	else if((Address < ADDR_FLASH_SECTOR_9) && (Address >= ADDR_FLASH_SECTOR_8))
	{
		sector = FLASH_SECTOR_8;
	}
	else if((Address < ADDR_FLASH_SECTOR_10) && (Address >= ADDR_FLASH_SECTOR_9))
	{
		sector = FLASH_SECTOR_9;
	}
	else if((Address < ADDR_FLASH_SECTOR_11) && (Address >= ADDR_FLASH_SECTOR_10))
	{
		sector = FLASH_SECTOR_10;
	}
	else	/*(Address < FLASH_END_ADDR) && (Address >= ADDR_FLASH_SECTOR_11))*/
	{
		sector = FLASH_SECTOR_11;
	}

	return sector;
}

/*
*********************************************************************************************************
*	  : bsp_ReadCpuFlash
*	˵: ȡCPU Flash
*	    :  _ucpDst : Ŀ껺
*			 _ulFlashAddr : ʼַ
*			 _ulSize : ݴСλֽڣ
*	  ֵ: 0=ɹ1=ʧ
*********************************************************************************************************
*/
uint8_t bsp_ReadCpuFlash(uint32_t _ulFlashAddr, uint8_t *_ucpDst, uint32_t _ulSize)
{
	uint32_t i;

	/* ƫƵַоƬ򲻸д */
	if (_ulFlashAddr + _ulSize > FLASH_BASE_ADDR + FLASH_SIZE)
	{
		return 1;
	}

	/* Ϊ0ʱ,ʼַΪַ */
	if (_ulSize == 0)
	{
		return 1;
	}

	for (i = 0; i < _ulSize; i++)
	{
		*_ucpDst++ = *(uint8_t *)_ulFlashAddr++;
	}

	return 0;
}

/*
*********************************************************************************************************
*	  : bsp_CmpCpuFlash
*	˵: ȽFlashַָ.
*	    : _ulFlashAddr : Flashַ
*			 _ucpBuf : ݻ
*			 _ulSize : ݴСλֽڣ
*	  ֵ:
*			FLASH_IS_EQU		0   FlashݺʹдȣҪд
*			FLASH_REQ_WRITE		1	FlashҪֱд
*			FLASH_REQ_ERASE		2	FlashҪȲ,д
*			FLASH_PARAM_ERR		3	
*********************************************************************************************************
*/
uint8_t bsp_CmpCpuFlash(uint32_t _ulFlashAddr, uint8_t *_ucpBuf, uint32_t _ulSize)
{
	uint32_t i;
	uint8_t ucIsEqu;	/* ȱ־ */
	uint8_t ucByte;

	/* ƫƵַоƬ򲻸д */
	if (_ulFlashAddr + _ulSize > FLASH_BASE_ADDR + FLASH_SIZE)
	{
		return FLASH_PARAM_ERR;		/**/
	}

	/* Ϊ0ʱȷ */
	if (_ulSize == 0)
	{
		return FLASH_IS_EQU;		/* Flashݺʹд */
	}

	ucIsEqu = 1;			/* ȼֽںʹдȣκһȣΪ 0 */
	for (i = 0; i < _ulSize; i++)
	{
		ucByte = *(uint8_t *)_ulFlashAddr;

		if (ucByte != *_ucpBuf)
		{
			if (ucByte != 0xFF)
			{
				return FLASH_REQ_ERASE;		/* Ҫд */
			}
			else
			{
				ucIsEqu = 0;	/* ȣҪд */
			}
		}

		_ulFlashAddr++;
		_ucpBuf++;
	}

	if (ucIsEqu == 1)
	{
		return FLASH_IS_EQU;	/* FlashݺʹдȣҪд */
	}
	else
	{
		return FLASH_REQ_WRITE;	/* FlashҪֱд */
	}
}

/*
*********************************************************************************************************
*	  : bsp_EraseCpuFlash
*	˵: CPU FLASHһ 128KB)
*	    : _ulFlashAddr : Flashַ
*	  ֵ: 0 ɹ 1 ʧ
*			  HAL_OK       = 0x00,
*			  HAL_ERROR    = 0x01,
*			  HAL_BUSY     = 0x02,
*			  HAL_TIMEOUT  = 0x03
*
*********************************************************************************************************
*/
uint8_t bsp_EraseCpuFlash(uint32_t _ulFlashAddr)
{
	uint32_t FirstSector = 0, NbOfSectors = 0;
	FLASH_EraseInitTypeDef EraseInitStruct;
	uint32_t SECTORError = 0;
	uint8_t re;

	/*  */
	HAL_FLASH_Unlock();
	
	/* ȡ˵ַڵ */
	FirstSector = bsp_GetSector(_ulFlashAddr);
	
	/* ̶1 */
	NbOfSectors = 1;	

	/*  */
	EraseInitStruct.TypeErase     = FLASH_TYPEERASE_SECTORS;
	EraseInitStruct.VoltageRange  = FLASH_VOLTAGE_RANGE_3;
	
	EraseInitStruct.Banks         = FLASH_BANK_1;

	EraseInitStruct.Sector        = FirstSector;
	EraseInitStruct.NbSectors     = NbOfSectors;
	
	/*  */	
	re = HAL_FLASHEx_Erase(&EraseInitStruct, &SECTORError);
	
	/* Ϻ */
	HAL_FLASH_Lock();	
	
	return re;
}

/*
*********************************************************************************************************
*	  : bsp_WriteCpuFlash
*	˵: дݵCPU ڲFlash
*	    : _ulFlashAddr : Flashַ
*			 _ucpSrc : ݻ
*			 _ulSize : ݴСλֽڣ
*	  ֵ: 0-ɹ1-ݳȻַ2-дFlash(Flash)
*********************************************************************************************************
*/
uint8_t bsp_WriteCpuFlash(uint32_t _ulFlashAddr, uint8_t *_ucpSrc, uint32_t _ulSize)
{
	uint32_t i;
	uint8_t ucRet;

	/* ƫƵַоƬ򲻸д */
	if (_ulFlashAddr + _ulSize > FLASH_BASE_ADDR + FLASH_SIZE)
	{
		return 1;
	}

	/* Ϊ0ʱ  */
	if (_ulSize == 0)
	{
		return 0;
	}

	ucRet = bsp_CmpCpuFlash(_ulFlashAddr, _ucpSrc, _ulSize);

	if (ucRet == FLASH_IS_EQU)
	{
		return 0;
	}

	__set_PRIMASK(1);  		/* ж */


	/* Ҫ */
	if (ucRet == FLASH_REQ_ERASE)
	{
		bsp_EraseCpuFlash(_ulFlashAddr);
	}

	/* FLASH  */
	HAL_FLASH_Unlock();
	
	/* ֽģʽ̣ΪЧʣ԰ֱ̣һд4ֽڣ */
	for (i = 0; i < _ulSize; i++)
	{
		HAL_FLASH_Program(FLASH_TYPEPROGRAM_BYTE, _ulFlashAddr++, *_ucpSrc++);
	}

  	/* Flash ֹдFlashƼĴ */
  	HAL_FLASH_Lock();

  	__set_PRIMASK(0);  		/* ж */

	return 0;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
