/*
*********************************************************************************************************
*
*	ģ : LEDָʾģ
*	ļ : bsp_led.c
*	     : V1.0
*	˵     : LEDָʾ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2018-09-05 armfly  ʽ
*
*	Copyright (C), 2015-2030,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	STM32-H7 LEDָʾ74HC574ģCPUIOֱ
	74HC574һ8·ڻFMCϡ
	74HC574Ϊ : bsp_fmc_io.c
*/

/*
*********************************************************************************************************
*	  : bsp_InitLed
*	˵: LEDָʾصGPIO,  ú bsp_Init() á
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitLed(void)
{
	bsp_LedOff(1);
	bsp_LedOff(2);
	bsp_LedOff(3);
	bsp_LedOff(4);
}

/*
*********************************************************************************************************
*	  : bsp_LedOn
*	˵: ָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedOn(uint8_t _no)
{
	if (_no == 1)
	{
		HC574_SetPin(LED1, 0);
	}
	else if (_no == 2)
	{
		HC574_SetPin(LED2, 0);
	}
	else if (_no == 3)
	{
		HC574_SetPin(LED3, 0);
	}
	else if (_no == 4)
	{
		HC574_SetPin(LED4, 0);
	}
}

/*
*********************************************************************************************************
*	  : bsp_LedOff
*	˵: ϨָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedOff(uint8_t _no)
{
	if (_no == 1)
	{
		HC574_SetPin(LED1, 1);
	}
	else if (_no == 2)
	{
		HC574_SetPin(LED2, 1);
	}
	else if (_no == 3)
	{
		HC574_SetPin(LED3, 1);
	}
	else if (_no == 4)
	{
		HC574_SetPin(LED4, 1);
	}
}

/*
*********************************************************************************************************
*	  : bsp_LedToggle
*	˵: תָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedToggle(uint8_t _no)
{
	uint32_t pin;
	
	if (_no == 1)
	{
		pin = LED1;
	}
	else if (_no == 2)
	{
		pin = LED2;
	}
	else if (_no == 3)
	{
		pin = LED3;
	}
	else if (_no == 4)
	{
		pin = LED4;
	}
	else
	{
		return;
	}

	if (HC574_GetPin(pin))
	{
		HC574_SetPin(pin, 0);
	}
	else
	{
		HC574_SetPin(pin, 1);
	}	
}

/*
*********************************************************************************************************
*	  : bsp_IsLedOn
*	˵: жLEDָʾǷѾ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 1ʾѾ0ʾδ
*********************************************************************************************************
*/
uint8_t bsp_IsLedOn(uint8_t _no)
{
	uint32_t pin;
	
	if (_no == 1)
	{
		pin = LED1;
	}
	else if (_no == 2)
	{
		pin = LED2;
	}
	else if (_no == 3)
	{
		pin = LED3;
	}
	else if (_no == 4)
	{
		pin = LED4;
	}
	else
	{
		return 0;
	}
	
	if (HC574_GetPin(pin))
	{
		return 0;	/*  */
	}
	else
	{
		return 1;	/*  */
	}
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
