/*
*********************************************************************************************************
*
*	ģ : ʱģ
*	ļ : bsp_timer.c
*	     : V1.5
*	˵     : systickʱΪϵͳδʱȱʡʱΪ1ms
*
*				ʵ˶ʱʹ(1ms) ͨ޸ TMR_COUNT ʱ
*				ʵmsӳٺ1ms usӳٺ
*				ʵϵͳʱ亯1msλ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*		V1.1    2013-06-21 armfly  usӳٺ bsp_DelayUS
*		V1.2    2014-09-07 armfly  TIM4 Ӳʱжϣʵusʱ.20us - 16
*		V1.3    2015-04-06 armfly   bsp_CheckRunTime(int32_t _LastTime) ʱֵ
*		V1.4	2015-05-22 armfly   bsp_InitHardTimer() ѡTIM2-5
*		V1.5	2018-11-26 armfly  s_tTmrֵ0; g_ucEnableSystickISRHALǰsystickж
*								   쳣
*
*	Copyright (C), 2015-2030,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"

/*
	ӲʱTIM ʹ TIM2 - TIM5
*/
#define USE_TIM2
//#define USE_TIM3
//#define USE_TIM4
//#define USE_TIM5

#ifdef USE_TIM2
	#define TIM_HARD					TIM2
	#define	RCC_TIM_HARD_CLK_ENABLE()	__HAL_RCC_TIM2_CLK_ENABLE()
	#define TIM_HARD_IRQn				TIM2_IRQn
	#define TIM_HARD_IRQHandler			TIM2_IRQHandler
#endif

#ifdef USE_TIM3
	#define TIM_HARD					TIM3
	#define	RCC_TIM_HARD_CLK_ENABLE()	__HAL_RCC_TIM3_CLK_ENABLE()	
	#define TIM_HARD_IRQn				TIM3_IRQn
	#define TIM_HARD_IRQHandler			TIM3_IRQHandler
#endif

#ifdef USE_TIM4
	#define TIM_HARD					TIM4
	#define	RCC_TIM_HARD_CLK_ENABLE()	__HAL_RCC_TIM4_CLK_ENABLE()
	#define TIM_HARD_IRQn				TIM4_IRQn
	#define TIM_HARD_IRQHandler			TIM4_IRQHandler
#endif

#ifdef USE_TIM5
	#define TIM_HARD					TIM5
	#define	RCC_TIM_HARD_CLK_ENABLE()	__HAL_RCC_TIM5_CLK_ENABLE()
	#define TIM_HARD_IRQn				TIM5_IRQn
	#define TIM_HARD_IRQHandler			TIM5_IRQHandler
#endif

/*  TIMʱжϵִеĻصָ */
static void (*s_TIM_CallBack1)(void);
static void (*s_TIM_CallBack2)(void);
static void (*s_TIM_CallBack3)(void);
static void (*s_TIM_CallBack4)(void);


/* 2ȫֱת bsp_DelayMS()  */
static volatile uint32_t s_uiDelayCount = 0;
static volatile uint8_t s_ucTimeOutFlag = 0;

/* ʱṹ */
static SOFT_TMR s_tTmr[TMR_COUNT] = {0};

/*
	ȫʱ䣬λ1ms
	Աʾ 24.85죬ĲƷʱ䳬뿼
*/
__IO int32_t g_iRunTime = 0;

static __IO uint8_t g_ucEnableSystickISR = 0;	/* ȴʼ */

static void bsp_SoftTimerDec(SOFT_TMR *_tmr);


/*
*********************************************************************************************************
*	  : bsp_InitTimer
*	˵: systickжϣʼʱ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitTimer(void)
{
	uint8_t i;

	/* еʱ */
	for (i = 0; i < TMR_COUNT; i++)
	{
		s_tTmr[i].Count = 0;
		s_tTmr[i].PreLoad = 0;
		s_tTmr[i].Flag = 0;
		s_tTmr[i].Mode = TMR_ONCE_MODE;	/* ȱʡ1Թģʽ */
	}

	/*
		systicжΪ1mssystickжϡ

    	SystemCoreClock ǹ̼жϵͳںʱӣSTM32F429,һΪ 168/180MHz

    	SysTick_Config() βαʾںʱӶٸں󴥷һSystickʱж.
	    	-- SystemCoreClock / 1000  ʾʱƵΪ 1000Hz ҲǶʱΪ  1ms
	    	-- SystemCoreClock / 500   ʾʱƵΪ 500Hz  ҲǶʱΪ  2ms
	    	-- SystemCoreClock / 2000  ʾʱƵΪ 2000Hz ҲǶʱΪ  500us

    	ڳӦãһȡʱ1msڵCPUߵ͹ӦãöʱΪ 10ms
    */
	SysTick_Config(SystemCoreClock / 1000);
	
	g_ucEnableSystickISR = 1;		/* 1ʾִsystickж */
	
	bsp_InitHardTimer();
}

/*
*********************************************************************************************************
*	  : SysTick_ISR
*	˵: SysTickжϷÿ1ms1
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
extern void bsp_RunPer1ms(void);
extern void bsp_RunPer10ms(void);
void SysTick_ISR(void)
{
	static uint8_t s_count = 0;
	uint8_t i;
	
	/* ÿ1ms1  bsp_DelayMS */
	if (s_uiDelayCount > 0)
	{
		if (--s_uiDelayCount == 0)
		{
			s_ucTimeOutFlag = 1;
		}
	}

	/* ÿ1msʱļмһ */
	for (i = 0; i < TMR_COUNT; i++)
	{
		bsp_SoftTimerDec(&s_tTmr[i]);
	}

	/* ȫʱÿ1ms1 */
	g_iRunTime++;
	if (g_iRunTime == 0x7FFFFFFF)	/*  int32_t ͣΪ 0x7FFFFFFF */
	{
		g_iRunTime = 0;
	}

	bsp_RunPer1ms();		/* ÿ1msһδ˺˺ bsp.c */

	if (++s_count >= 10)
	{
		s_count = 0;

		bsp_RunPer10ms();	/* ÿ10msһδ˺˺ bsp.c */
	}
}

/*
*********************************************************************************************************
*	  : bsp_SoftTimerDec
*	˵: ÿ1msжʱ1뱻SysTick_ISRԵá
*	    :  _tmr : ʱָ
*	  ֵ: 
*********************************************************************************************************
*/
static void bsp_SoftTimerDec(SOFT_TMR *_tmr)
{
	if (_tmr->Count > 0)
	{
		/* ʱ1öʱ־ */
		if (--_tmr->Count == 0)
		{
			_tmr->Flag = 1;

			/* ԶģʽԶװ */
			if(_tmr->Mode == TMR_AUTO_MODE)
			{
				_tmr->Count = _tmr->PreLoad;
			}
		}
	}
}

/*
*********************************************************************************************************
*	  : bsp_DelayMS
*	˵: msӳ٣ӳپΪ1ms
*	    :  n : ӳٳȣλ1 ms n Ӧ2
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_DelayMS(uint32_t n)
{
	if (n == 0)
	{
		return;
	}
	else if (n == 1)
	{
		n = 2;
	}

	DISABLE_INT();  			/* ж */

	s_uiDelayCount = n;
	s_ucTimeOutFlag = 0;

	ENABLE_INT();  				/* ж */

	while (1)
	{
		bsp_Idle();				/* CPUִеĲ  bsp.c  bsp.h ļ */

		/*
			ȴӳʱ䵽
			ע⣺Ϊ s_ucTimeOutFlag = 0ԿŻ s_ucTimeOutFlag Ϊ volatile
		*/
		if (s_ucTimeOutFlag == 1)
		{
			break;
		}
	}
}

/*
*********************************************************************************************************
*      : bsp_DelayUS
*    ˵: usӳ١ systickʱܵô˺
*        :  n : ӳٳȣλ1 us
*      ֵ: 
*********************************************************************************************************
*/
void bsp_DelayUS(uint32_t n)
{
    uint32_t ticks;
    uint32_t told;
    uint32_t tnow;
    uint32_t tcnt = 0;
    uint32_t reload;
       
	reload = SysTick->LOAD;                
    ticks = n * (SystemCoreClock / 1000000);	 /* ҪĽ */  
    
    tcnt = 0;
    told = SysTick->VAL;             /* սʱļֵ */

    while (1)
    {
        tnow = SysTick->VAL;    
        if (tnow != told)
        {    
            /* SYSTICKһݼļ */    
            if (tnow < told)
            {
                tcnt += told - tnow;    
            }
            /* װصݼ */
            else
            {
                tcnt += reload - tnow + told;    
            }        
            told = tnow;

            /* ʱ䳬/Ҫӳٵʱ,˳ */
            if (tcnt >= ticks)
            {
            	break;
            }
        }  
    }
} 

/*
*********************************************************************************************************
*	  : bsp_StartTimer
*	˵: һʱöʱڡ
*	    :  	_id     : ʱIDֵ0,TMR_COUNT-1ûάʱIDԱⶨʱIDͻ
*				_period : ʱڣλ1ms
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_StartTimer(uint8_t _id, uint32_t _period)
{
	if (_id >= TMR_COUNT)
	{
		/* ӡԴļ */
		BSP_Printf("Error: file %s, function %s()\r\n", __FILE__, __FUNCTION__);
		while(1); /* 쳣ȴŹλ */
	}

	DISABLE_INT();  			/* ж */

	s_tTmr[_id].Count = _period;		/* ʵʱֵ */
	s_tTmr[_id].PreLoad = _period;		/* ԶװֵԶģʽ */
	s_tTmr[_id].Flag = 0;				/* ʱʱ䵽־ */
	s_tTmr[_id].Mode = TMR_ONCE_MODE;	/* 1Թģʽ */

	ENABLE_INT();  				/* ж */
}

/*
*********************************************************************************************************
*	  : bsp_StartAutoTimer
*	˵: һԶʱöʱڡ
*	    :  	_id     : ʱIDֵ0,TMR_COUNT-1ûάʱIDԱⶨʱIDͻ
*				_period : ʱڣλ10ms
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_StartAutoTimer(uint8_t _id, uint32_t _period)
{
	if (_id >= TMR_COUNT)
	{
		/* ӡԴļ */
		BSP_Printf("Error: file %s, function %s()\r\n", __FILE__, __FUNCTION__);
		while(1); /* 쳣ȴŹλ */
	}

	DISABLE_INT();  		/* ж */

	s_tTmr[_id].Count = _period;			/* ʵʱֵ */
	s_tTmr[_id].PreLoad = _period;		/* ԶװֵԶģʽ */
	s_tTmr[_id].Flag = 0;				/* ʱʱ䵽־ */
	s_tTmr[_id].Mode = TMR_AUTO_MODE;	/* Զģʽ */

	ENABLE_INT();  			/* ж */
}

/*
*********************************************************************************************************
*	  : bsp_StopTimer
*	˵: ֹͣһʱ
*	    :  	_id     : ʱIDֵ0,TMR_COUNT-1ûάʱIDԱⶨʱIDͻ
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_StopTimer(uint8_t _id)
{
	if (_id >= TMR_COUNT)
	{
		/* ӡԴļ */
		BSP_Printf("Error: file %s, function %s()\r\n", __FILE__, __FUNCTION__);
		while(1); /* 쳣ȴŹλ */
	}

	DISABLE_INT();  	/* ж */

	s_tTmr[_id].Count = 0;				/* ʵʱֵ */
	s_tTmr[_id].Flag = 0;				/* ʱʱ䵽־ */
	s_tTmr[_id].Mode = TMR_ONCE_MODE;	/* Զģʽ */

	ENABLE_INT();  		/* ж */
}

/*
*********************************************************************************************************
*	  : bsp_CheckTimer
*	˵: ⶨʱǷʱ
*	    :  	_id     : ʱIDֵ0,TMR_COUNT-1ûάʱIDԱⶨʱIDͻ
*				_period : ʱڣλ1ms
*	  ֵ:  0 ʾʱδ 1ʾʱ
*********************************************************************************************************
*/
uint8_t bsp_CheckTimer(uint8_t _id)
{
	if (_id >= TMR_COUNT)
	{
		return 0;
	}

	if (s_tTmr[_id].Flag == 1)
	{
		s_tTmr[_id].Flag = 0;
		return 1;
	}
	else
	{
		return 0;
	}
}

/*
*********************************************************************************************************
*	  : bsp_GetRunTime
*	˵: ȡCPUʱ䣬λ1msԱʾ 24.85죬ĲƷʱ䳬뿼
*	    :  
*	  ֵ: CPUʱ䣬λ1ms
*********************************************************************************************************
*/
int32_t bsp_GetRunTime(void)
{
	int32_t runtime;

	DISABLE_INT();  	/* ж */

	runtime = g_iRunTime;	/* SystickжбдҪжϽб */

	ENABLE_INT();  		/* ж */

	return runtime;
}

/*
*********************************************************************************************************
*	  : bsp_CheckRunTime
*	˵: 㵱ǰʱ͸ʱ֮Ĳֵ˼ѭ
*	    :  _LastTime ϸʱ
*	  ֵ: ǰʱ͹ȥʱĲֵλ1ms
*********************************************************************************************************
*/
int32_t bsp_CheckRunTime(int32_t _LastTime)
{
	int32_t now_time;
	int32_t time_diff;

	DISABLE_INT();  	/* ж */

	now_time = g_iRunTime;	/* SystickжбдҪжϽб */

	ENABLE_INT();  		/* ж */
	
	if (now_time >= _LastTime)
	{
		time_diff = now_time - _LastTime;
	}
	else
	{
		time_diff = 0x7FFFFFFF - _LastTime + now_time;
	}

	return time_diff;
}

/*
*********************************************************************************************************
*	  : SysTick_Handler
*	˵: ϵͳશʱжϷļ˸ú
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void SysTick_Handler(void)
{
	HAL_IncTick();	/* ST HALĵδʱжϷ */
	
	if (g_ucEnableSystickISR == 0)
	{
		return;
	}
	
	SysTick_ISR();	/* bspĵδʱжϷ */
}

/*
*********************************************************************************************************
*	ĴʹһTIM4жϣʵ4Ӳʱ
*********************************************************************************************************
*/

#ifdef TIM_HARD

/*
*********************************************************************************************************
*	  : bsp_InitHardTimer
*	˵:  TIMxusӲʱTIMxУֹͣ.
*			TIMxTIM2 - TIM5 ֮TIM, ЩTIM4ͨ,  APB1 ϣʱ=SystemCoreClock / 2
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitHardTimer(void)
{
    TIM_HandleTypeDef  TimHandle = {0};
	uint32_t usPeriod;
	uint16_t usPrescaler;
	uint32_t uiTIMxCLK;
	TIM_TypeDef* TIMx = TIM_HARD;
	
	RCC_TIM_HARD_CLK_ENABLE();		/* ʹTIMʱ */
	
    /*-----------------------------------------------------------------------
		system_stm32f4xx.c ļ void SetSysClock(void) ʱӵ£

		HCLK = SYSCLK / 1     (AHB1Periph)
		PCLK2 = HCLK / 2      (APB2Periph)
		PCLK1 = HCLK / 4      (APB1Periph)

		ΪAPB1 prescaler != 1,  APB1ϵTIMxCLK = PCLK1 x 2 = SystemCoreClock / 2;
		ΪAPB2 prescaler != 1,  APB2ϵTIMxCLK = PCLK2 x 2 = SystemCoreClock;

		APB1 ʱ TIM2, TIM3 ,TIM4, TIM5, TIM6, TIM7, TIM12, TIM13,TIM14
		APB2 ʱ TIM1, TIM8 ,TIM9, TIM10, TIM11

	----------------------------------------------------------------------- */
	uiTIMxCLK = SystemCoreClock / 2;

	usPrescaler = uiTIMxCLK / 1000000 - 1;	/* Ƶ = 1 */
	
	if (TIMx == TIM2 || TIMx == TIM5)
	{
		usPeriod = 0xFFFFFFFF;
	}
	else
	{
		usPeriod = 0xFFFF;
	}

	/* 
       ÷ƵΪusPrescalerôʱ1ξ1us
       usPeriodֵǾ
       usPeriod = 0xFFFF ʾ0xFFFF΢롣
       usPeriod = 0xFFFFFFFF ʾ0xFFFFFFFF΢롣
    */
	TimHandle.Instance = TIMx;
	TimHandle.Init.Prescaler         = usPrescaler;
	TimHandle.Init.Period            = usPeriod;
	TimHandle.Init.ClockDivision     = 0;
	TimHandle.Init.CounterMode       = TIM_COUNTERMODE_UP;
	TimHandle.Init.RepetitionCounter = 0;
    TimHandle.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
	
	if (HAL_TIM_Base_Init(&TimHandle) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}

	/* öʱжϣCCȽжʹ */
	{
		HAL_NVIC_SetPriority(TIM_HARD_IRQn, 0, 2);
		HAL_NVIC_EnableIRQ(TIM_HARD_IRQn);	
	}
    
    /* ʱ */
	HAL_TIM_Base_Start(&TimHandle);
}

/*
*********************************************************************************************************
*	  : bsp_StartHardTimer
*	˵: ʹTIM2-5ζʱʹ, ʱʱ䵽ִлصͬʱ4ʱͨš
*             ʱ1us Ҫķڵñִʱ䣩
*			  TIM2TIM5 32λʱʱΧܴ
*			  TIM3TIM4 16λʱ
*	    : _CC : Ƚͨ123, 4
*             _uiTimeOut : ʱʱ, λ 1us. 16λʱ 65.5ms; 32λʱ 4294
*             _pCallBack : ʱʱ䵽󣬱ִеĺ
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_StartHardTimer(uint8_t _CC, uint32_t _uiTimeOut, void * _pCallBack)
{
    uint32_t cnt_now;
    uint32_t cnt_tar;
	TIM_TypeDef* TIMx = TIM_HARD;
	
    /* 貹ӳ٣ʵ⾫1us */
    
    cnt_now = TIMx->CNT; 
    cnt_tar = cnt_now + _uiTimeOut;			/* 㲶ļֵ */
    if (_CC == 1)
    {
        s_TIM_CallBack1 = (void (*)(void))_pCallBack;

		TIMx->CCR1 = cnt_tar; 			    /* òȽϼCC1 */
        TIMx->SR = (uint16_t)~TIM_IT_CC1;   /* CC1жϱ־ */
		TIMx->DIER |= TIM_IT_CC1;			/* ʹCC1ж */
	}
    else if (_CC == 2)
    {
		s_TIM_CallBack2 = (void (*)(void))_pCallBack;

		TIMx->CCR2 = cnt_tar;				/* òȽϼCC2 */
        TIMx->SR = (uint16_t)~TIM_IT_CC2;	/* CC2жϱ־ */
		TIMx->DIER |= TIM_IT_CC2;			/* ʹCC2ж */
    }
    else if (_CC == 3)
    {
        s_TIM_CallBack3 = (void (*)(void))_pCallBack;

		TIMx->CCR3 = cnt_tar;				/* òȽϼCC3 */
        TIMx->SR = (uint16_t)~TIM_IT_CC3;	/* CC3жϱ־ */
		TIMx->DIER |= TIM_IT_CC3;			/* ʹCC3ж */
    }
    else if (_CC == 4)
    {
        s_TIM_CallBack4 = (void (*)(void))_pCallBack;

		TIMx->CCR4 = cnt_tar;				/* òȽϼCC4 */
        TIMx->SR = (uint16_t)~TIM_IT_CC4;	/* CC4жϱ־ */
		TIMx->DIER |= TIM_IT_CC4;			/* ʹCC4ж */
    }
	else
    {
        return;
    }
}

/*
*********************************************************************************************************
*	  : TIMx_IRQHandler
*	˵: TIM жϷ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void TIM_HARD_IRQHandler(void)
{
	uint16_t itstatus = 0x0, itenable = 0x0;
	TIM_TypeDef* TIMx = TIM_HARD;
	
    
  	itstatus = TIMx->SR & TIM_IT_CC1;
	itenable = TIMx->DIER & TIM_IT_CC1;
    
	if ((itstatus != (uint16_t)RESET) && (itenable != (uint16_t)RESET))
	{
		TIMx->SR = (uint16_t)~TIM_IT_CC1;
		TIMx->DIER &= (uint16_t)~TIM_IT_CC1;		/* CC1ж */	

        /* ȹرжϣִлصΪصҪʱ */
        s_TIM_CallBack1();
    }

	itstatus = TIMx->SR & TIM_IT_CC2;
	itenable = TIMx->DIER & TIM_IT_CC2;
	if ((itstatus != (uint16_t)RESET) && (itenable != (uint16_t)RESET))
	{
		TIMx->SR = (uint16_t)~TIM_IT_CC2;
		TIMx->DIER &= (uint16_t)~TIM_IT_CC2;		/* CC2ж */	

        /* ȹرжϣִлصΪصҪʱ */
        s_TIM_CallBack2();
    }

	itstatus = TIMx->SR & TIM_IT_CC3;
	itenable = TIMx->DIER & TIM_IT_CC3;
	if ((itstatus != (uint16_t)RESET) && (itenable != (uint16_t)RESET))
	{
		TIMx->SR = (uint16_t)~TIM_IT_CC3;
		TIMx->DIER &= (uint16_t)~TIM_IT_CC3;		/* CC2ж */	

        /* ȹرжϣִлصΪصҪʱ */
        s_TIM_CallBack3();
    }

	itstatus = TIMx->SR & TIM_IT_CC4;
	itenable = TIMx->DIER & TIM_IT_CC4;
	if ((itstatus != (uint16_t)RESET) && (itenable != (uint16_t)RESET))
	{
		TIMx->SR = (uint16_t)~TIM_IT_CC4;
		TIMx->DIER &= (uint16_t)~TIM_IT_CC4;		/* CC4ж */	

        /* ȹرжϣִлصΪصҪʱ */
        s_TIM_CallBack4();
    }	
}

#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
